/*
 * Created on 18.11.2004
 * This class is the mainclass of infoscreen
 */
package infoscreen;

/**
 * @author Christian Desktop
 * MainClass of infoscreenpackage
 */
public class Infoscreen {
 
	InternalProgramEventManager		eventManager;
	NetworkInterface				networkInterface;
	NewsContainer					newsContainer;
	NewsSheduler					newsSheduler;
	NewsRenderer					newsRenderer;
	GuiObjects						guiObjects;
	
	public Infoscreen (String infoscreenName, String Mode, String url)
	{
	  System.out.println("Instanz angelegt ... START.");	
	  
	  // HAUOTOBJEKTE WERDEN ANGELEGT
	  
	  // 1. InternalProgramEventManager
	  // bei ihm werden alle anderen HauptObjekte registriert
	  // er bildet eine alternative Kommunikationsstruktur zwischen den Objekten
	  this.eventManager = new InternalProgramEventManager(infoscreenName, Mode, url);
	  
	  // 2. GuiObjects
	  // Dieses Objekt verwaltet alle GUI-Objekte des Infoscreens
	  this.guiObjects = new GuiObjects(this.eventManager);
	  this.guiObjects.printStatus("Init GUI");

	  // 3. NewsContainer
	  // Dieses Objekt verwaltet alle aktuellen Nachrichten
	  this.guiObjects.printStatus("Init NewsContainer");
	  this.newsContainer = new NewsContainer(this.eventManager);	  
	  
	  // 4. NewsRenderer
	  // Dieses Objekt entscheidet ber die Ausgabe einer Nachricht
	  this.guiObjects.printStatus("Init NewsRenderer");
	  this.newsRenderer = new NewsRenderer(this.guiObjects, this.eventManager);
	  
	  // 5. NewsSheduler
	  // Dieses Objekt regelt welche Nachricht wann angezeigt wird
	  this.guiObjects.printStatus("Init NewsSheduler");	  
	  this.newsSheduler = new NewsSheduler(this.newsContainer, this.newsRenderer, this.eventManager);

	  // 6. Networkinterface
	  // Dieses Objekt regelt das Empfangen von neuen Nachrichten
	  this.guiObjects.printStatus("Init Networkinterface");	  
	  this.networkInterface = new NetworkInterface(this.newsContainer, this.eventManager);
	}
	
	public static void main(String[] args) {
		
		if (args.length == 3)
		{
		  if ( (args[1].equals("standalone")) || (args[1].equals("remote")) )	
		  {
			  System.out.println("Starting Infoscreen ...");
			  Infoscreen instanz = new Infoscreen(args[0], args[1], args[2]);		  	
		  }
		  else
		  {
		  	System.out.println("Der zweite Parameter kann nur 'standalone' oder 'remote' lauten. nicht:"+args[1]);	
		  }
		}  
		else
		{			
		  System.out.println("3 Parameter werden benoetigt: InfoscreenID Modus URL");
		  System.out.println(" - InfoscreenID: Der eindeutige Name des Infoscreens (ein Wort)");
		  System.out.println(" - Modus: Entweder 'standalone' oder 'remote'");
		  System.out.println(" - URL: Die WWW-Adresse des NewsFeeds oder des Steuerscripts");
		}
	}
}
