/*
 * Created on 18.11.2004
 */
package infoscreen;

import java.util.*;

/**
 * @author Christian Desktop
 */
public class InternalProgramEventManager {
	
	// Vector speichert alle Referenzen auf beim Manager registrierte Objekte
	Vector objectContainer;
	
	// Die Programmparameter
	String  InfoscreenName;
	String  Mode;
	String  Url;
	boolean ProxyMode;
	
	// Konstruktor
	public InternalProgramEventManager(String infoscreenName, String mode, String url)
	{
	  this.objectContainer 	= new Vector(6,2);	
	  this.InfoscreenName 	= infoscreenName;
	  this.Mode 			= mode;
	  this.Url 				= url;
	  if (this.Url.endsWith("/")) {this.Url = this.Url.substring(0,this.Url.length()-1);}
	  this.ProxyMode 		= false;	  
	}
	
	// Ein Objekt beim Manager registrieren
	public void register (InternalProgramEventListener ipel)
	{
	  objectContainer.add(ipel); 
	}
	
	// Befiehlt dem NewsSheduler zu starten
	public void startSheduler()
	{
	  // Befehl erzeugen und versenden
	  InternalProgramEvent event = new InternalProgramEvent("startSheduler","");
	  this.sendEvent(event);		
	}
	
	// Befiehlt dem NewsSheduler zu stoppen
	public void stopSheduler()
	{
	  // Befehl erzeugen und versenden
	  InternalProgramEvent event = new InternalProgramEvent("stopSheduler","");
	  this.sendEvent(event);		
	}	
	
	// Befiehlt DatenInfos an die Gui zu schicken
	public void requestDataInfoUpdate()
	{
	  // Befehl erzeugen und versenden
	  InternalProgramEvent event = new InternalProgramEvent("dataInfoUpdateRequest","");
	  this.sendEvent(event);		
	}
	
	// Befiehlt DatenInfos an die Gui zu schicken
	public void requestNewsflash(String newstext, String Duration)
	{
	  // Befehl erzeugen und versenden
	  InternalProgramEvent event = new InternalProgramEvent("newsflash",Duration+":"+newstext);
	  this.sendEvent(event);		
	}	
	
	// Befiehlt DatenInfos an die Gui zu schicken
	public void dataInfoUpdate(String data)
	{
	  // Befehl erzeugen und versenden
	  InternalProgramEvent event = new InternalProgramEvent("dataInfoUpdate",data);
	  this.sendEvent(event);		
	}		
	
	// Fragt bei der GUI an, ob in den NewsShowModus gewechselt werden kann
	public void requestNewsShowModus()
	{
	  // Ausgabe auf Konsole		
		
	  // Befehl erzeugen und versenden
	  InternalProgramEvent event = new InternalProgramEvent("requestNewsShowModus","");
	  this.sendEvent(event);		
	}	
	
	// Einen FehlerEvent erzeugen und ausgeben
	public void fehlerMeldung (String fehlertext)
	{
      // Ausgabe auf Konsole
	  System.out.println(fehlertext);
	  
	  // FehlerEvent erzeugen und versenden
	  InternalProgramEvent event = new InternalProgramEvent("fehlermeldung",fehlertext);
	  this.sendEvent(event);
	  
	}
	
	// Einen InfoEvent erzeugen und ausgeben
	public void infoMeldung (String infotext)
	{
      // Ausgabe auf Konsole
	  System.out.println(infotext);
	  
	  // FehlerEvent erzeugen und versenden
	  InternalProgramEvent event = new InternalProgramEvent("infomeldung",infotext);
	  this.sendEvent(event);
	  
	}	
	
	// Getter fr den InfoscreenNamen
	public String getInfoscreenName()
	{
	  return this.InfoscreenName;	
	}
	
	// Getter fr den Modus
	public String getModus()
	{
	  return this.Mode;	
	}	
	
	// Getter fr die URL
	public String getUrl()
	{
	  return this.Url;	
	}	

	// Getter fr die URL
	public boolean getProxyMode()
	{
	  return this.ProxyMode;	
	}	
	
	// Setter fr ProxyMode
	public void setProxyMode(boolean mode)
	{
	  this.ProxyMode = mode;	
	}
	
	// Event an alle registrierten Objekte versenden
	public void sendEvent (InternalProgramEvent event)
	{		
      for (Enumeration e = objectContainer.elements() ; e.hasMoreElements() ;) 
      {
        ((InternalProgramEventListener)(e.nextElement())).internalProgramEventHappend(event);
      }
	}

}
