/*
 * Created on 18.11.2004
 */
package infoscreen;

import java.util.*;

import com.sun.syndication.feed.*;
import com.sun.syndication.feed.rss.*;
import com.sun.syndication.feed.synd.*;
import com.sun.syndication.io.*;

import org.jdom.*;

/**
 * @author Christian Desktop
 */
public class NewsContainer   
  implements InternalProgramEventListener
{

	private InternalProgramEventManager	eventManager;
	
	private Vector NewsObjectContainer;
	
	private String  channelFilter_Name;
	private int     channelFilter_Importance;	
	private int     channelFilter_Daylimit;
	
	private String lastChannelName  = "";
	private int    channelCountDown = 0;
	
	private String  feedUrl;
	
	
	public NewsContainer (InternalProgramEventManager ipem)
	{
	  // Referenzen kopieren
		this.eventManager = ipem;	
	  
	  // Beim eventManager registrieren
	  this.eventManager.register(this);	
	  
	  // NewsObjectContainer initialisieren
	  this.NewsObjectContainer = new Vector(50,10);
	  
	  // Importparameter initialisieren
	  this.setFeedImportParameter("", 3, 0);
	}

	public int getNumberOfNewsObjects()
	{
	  return this.NewsObjectContainer.size();	
	}
	
	public void addNewsObject (NewsObject newsObject)
	{		
      // Prfen, of die Nachricht nicht zu alt ist	
      long ageOfNews 	 = (((new Date()).getTime()) - newsObject.getDate());
      long secondLimit  = this.channelFilter_Daylimit * 60 * 60 * 24;
      if (( secondLimit > ageOfNews ) || (this.channelFilter_Daylimit==0))
      {		
		if ((newsObject.getHeadline()!=null) && (newsObject.getHeadline()!="") && (!this.headlineExits(newsObject.getHeadline())))
		{
           // Die Nachricht kann eingetragen werden	
		   this.NewsObjectContainer.add(newsObject);
         }
	    }
        else
        {
          System.out.println("- Die Nachricht ist zu alt. "+ageOfNews+">"+secondLimit+" / "+ ((new Date()).getTime())+"-"+newsObject.getDate());	
        }	
	}
	
	public void createImpressum(String name, String mail, String post)
	{
	  NewsObject newsObjekt = new NewsObject("Impressum",name,"Impressum");	
	  newsObjekt.addText("Die Redaktion des Infoscreens ist zu erreichen unter:<br><br>"+mail+"<br>oder<br>"+post+"<br><br>Namentlich gekennzeichnete Artikel mssen nicht mit der Meinung der Redaktion bereinstimmen.","");
	  newsObjekt.setImportance(1);
	  this.addNewsObject(newsObjekt);
	}
	
	private double getDisplayIndex(long jetztZeit, long maxAlt, long newsAlt, int importance)
	{
	  double zeitIndex    = ( ( ((jetztZeit-(newsAlt+1)) / (double)(jetztZeit-(maxAlt+1))) ));
	  double wichtigIndex = (double)((importance)/5.0);
	  double index        = ( (0.7 * zeitIndex) + (0.3 * wichtigIndex) );
	  System.out.println("DisplayIndex: "+zeitIndex+" / "+index);
	  return index;
	}
	
	// setzt die Parameter fr das nchste Feed, dass importiert wird
	// name = Name des Channels
	// importance = MixAnteil des Kanals (1-5)
	// daylimit = Nur Nachrichten, die X Tage alt sind (0=no limit)
	public void setFeedImportParameter(String name, int importance ,int daylimit)
	{
		this.channelFilter_Name 		= name;
		this.channelFilter_Importance 	= importance; 		
		this.channelFilter_Daylimit 	= daylimit; 
	}
	
	// liefert das nchste Newsobjekt
	public NewsObject getNextNewsObjekt()
	{
      NewsObject nextNewsObject = null;
      if (this.NewsObjectContainer.size() > 0)
      {		
      	  System.out.println("################################################");
      	  // Es wird generell der gleiche Channel gewhlt ...
      	  String nextChannel = this.lastChannelName; 
      	  boolean changeChannel = false;
	      if (this.channelCountDown == 0) {changeChannel=true;}
      	
      	  double highestIndex  = -1;
      	  
      	  long jetztZeit = (new Date()).getTime();
      	  
      	  long timeRange = getOldestDisplayTime();
      	  
          if (changeChannel)
          {	  
            // Finde die nchste News aus einem anderen Channel
	        for (Enumeration e = NewsObjectContainer.elements() ; e.hasMoreElements() ;) 
	        {
	          NewsObject actualNewsObject = ((NewsObject)(e.nextElement()));
	          double actualIndex = this.getDisplayIndex(jetztZeit,timeRange,actualNewsObject.getDisplayTimestamp(),actualNewsObject.getImportance());
	          if (actualIndex > highestIndex)
	          {
          	    if (!this.lastChannelName.equals(actualNewsObject.getChannelName()))
                {      
          	      nextNewsObject = actualNewsObject;	
                  highestIndex = actualIndex;
                }  
	          }
	        }
          }
	        
	        // Wenn keine News in einem anderem Channel gefunden
	        // muss im gleichen gesucht werden
        	if (highestIndex==-1)
          	{
          	  changeChannel=false;	
          	}
        	
            // Finde die nchste News aus dem gleichen Channel       	
            if (!changeChannel)
            {	  
              // Finde die nchste News aus einem anderen Channel
  	          for (Enumeration e = NewsObjectContainer.elements() ; e.hasMoreElements() ;) 
  	          {
  	            NewsObject actualNewsObject = ((NewsObject)(e.nextElement()));
  	            double actualIndex = this.getDisplayIndex(jetztZeit,timeRange,actualNewsObject.getDisplayTimestamp(),actualNewsObject.getImportance());
  	            if (actualIndex > highestIndex)
  	            {
            	  if (this.lastChannelName.equals(actualNewsObject.getChannelName()))
                  {      
            	    nextNewsObject = actualNewsObject;	
                    highestIndex = actualIndex;
                  }  
  	            }
  	           }
             }
	      
  	      // Markiere das gefundene NewsObject als angezeigt
  	      nextNewsObject.setDisplayed();
	      
      	  if (changeChannel)
      	  {
      	  	// Generell wir der ChannelCountDown (Anzahl der Nachrichten am Stck aus diesem Kanal)
      	  	// aus dem Impotance-Wert des Kanals gewhlt    	  
      	  	this.channelCountDown = nextNewsObject.getImportance();	  
      	  	
      	  	// Ausser die Anzahl der Nachrichten aus diesem Channel stehen dazu um krassen Gegensatz
      	    int anz = this.NewsObjectsFromChannel(nextNewsObject.getChannelName());
      	  	if (anz==1) 							{ this.channelCountDown = 1;  }
      	  	else if (anz*2 < this.channelCountDown) { this.channelCountDown = anz*2; }
      	  	
    	    // Letzten Kanal aufwerten, wenn er sehr wichtig aber nur wenigen Nachrichten praesent ist
    	    anz = this.NewsObjectsFromChannel(this.lastChannelName);
    	    int imp = this.getChannelImportance(this.lastChannelName);
    	    if (anz < imp)
    	    {
    	      this.setChannelDisplaytimeBack(this.lastChannelName, imp-anz+1);
    	    }     
    	    //System.out.println("Change Channel: alt="+this.lastChannelName+" neu="+nextNewsObject.getChannelName()+" neuanzahl:"+this.channelCountDown);
      	  }    	   
      	  
  	      this.lastChannelName  = nextNewsObject.getChannelName();     	  
	      this.channelCountDown = this.channelCountDown - 1;
      }
      return nextNewsObject;
	}
	
	private int NewsObjectsFromChannel(String channelName)
	{
	  int i = 0;
      for (Enumeration e = NewsObjectContainer.elements() ; e.hasMoreElements() ;) 
      {
        if (((NewsObject)(e.nextElement())).getChannelName().equals(channelName))
        {i++;}
      }					
	  return i;	
	}
	
	private long getOldestDisplayTime()
	{
	  long i = 0;
	  Date actualDate = new Date();		
	  i = actualDate.getTime(); 
	  
      for (Enumeration e = NewsObjectContainer.elements() ; e.hasMoreElements() ;) 
      {
      	NewsObject no = ((NewsObject)(e.nextElement()));
		if (no.getDisplayTimestamp() < i)
        {i = no.getDisplayTimestamp();}
      }					
	  return i;			
	}
	
	private int getChannelImportance(String channelName)
	{
      for (Enumeration e = NewsObjectContainer.elements() ; e.hasMoreElements() ;) 
      {
      	NewsObject no = (NewsObject)(e.nextElement());
        if (no.getChannelName().equals(channelName))
        {return no.getImportance();}
      }					
	  return 3;	
	}
	
	private void setChannelDisplaytimeBack(String channelName, int halfminutes)
	{
      for (Enumeration e = NewsObjectContainer.elements() ; e.hasMoreElements() ;) 
      {
      	NewsObject no = (NewsObject)(e.nextElement());
        if (no.getChannelName().equals(channelName))
        {
          no.setDiplayedBack(halfminutes);
        }
      }					
	}
	
	// Setzt alle NewsObjekte auf "dirty"
	// Dies ist fr ein Update des Newsbestandes:
	// 1. Alles dirty setzten
	// 2. Wenn NewsObjekte die noch aktuell sind werden wieder auf dirty=false gesetzt
	// 3. Alle die nich dirty sind werden gelscht
	public void setAllDirty()
	{
	  System.out.println("NewsContainer: All News got Dirtyflag.");
      for (Enumeration e = NewsObjectContainer.elements() ; e.hasMoreElements() ;) 
      {
        ((NewsObject)(e.nextElement())).setDirty(true);
      }	
	}
	
	public boolean headlineExits(String headline)
	{
	  boolean result = false;	
      for (Enumeration e = NewsObjectContainer.elements() ; e.hasMoreElements() ;) 
      {
      	NewsObject news = ((NewsObject)(e.nextElement()));
        if (news.getHeadline().equals(headline))
        {
          result = true;	
          // wird nicht mehr als dirty gesetzt (weil auf jeden Fall aktuell)
          news.setDirty(false);
        }
      }	
      return result;
	}
	
	// Lscht alle NewsObjekte die "dirty" sind
	// Dies ist fr ein Update des Newsbestandes:
	// 1. Alles dirty setzten
	// 2. Wenn NewsObjekte die noch aktuell sind werden wieder auf dirty=false gesetzt
	// 3. Alle die nich dirty sind werden gelscht	
	public void deleteAllDirtyNews()
	{
	  System.out.println("NewsContainer: All dirty News is getting deleted.");		
      for (Enumeration e = NewsObjectContainer.elements() ; e.hasMoreElements() ;) 
      {
      	NewsObject news = ((NewsObject)(e.nextElement()));
        if (news.getDirtyFlag())
        	this.NewsObjectContainer.remove(news);
      }		  	
	}
	
	public void importFeedFromURLString(String url)
	{
		
	  this.eventManager.infoMeldung("Importiere Nachrichten-Feed / Update NewsData");	 
       	
   	   // Aus dem Feed-String ein SynFeed mit dem ROMEPARSER erstellen
   	   // siehe ihttp://wiki.java.net/bin/view/Javawsxml/Rome04
          
      WireFeedInput   wireInput  = new WireFeedInput();
      
      WireFeed wireFeed	   = null;
      
      try {
          
        wireFeed = wireInput.build(new XmlReader(new java.net.URL(url)));
        
        System.out.println("FeedType:"+wireFeed.getFeedType());
        System.out.println("Klassentyp:"+wireFeed.getClass().getName());  
        
        this.feedUrl = url;
        
        if (wireFeed.getClass().getName().equals("com.sun.syndication.feed.rss.Channel"))
        {
          // RSS Channel importieren
          com.sun.syndication.feed.rss.Channel channel = (com.sun.syndication.feed.rss.Channel) wireFeed;
          this.importRssChannel(channel);
        }
        else if (wireFeed.getClass().getName().equals("com.sun.syndication.feed.atom.Feed"))
        {
          // ATOM Feed als SyndFeed importieren
          SyndFeedInput synInput = new SyndFeedInput(); 
          WireFeedOutput wireOutput = new WireFeedOutput();
          SyndFeed sfeed = synInput.build(wireOutput.outputJDom(wireFeed));
          this.importSyndFeed(sfeed);
        }
        
        // Importfilter zurcksetzten
        this.channelFilter_Name       = "";
        this.channelFilter_Daylimit   = 0;
        this.channelFilter_Importance = 3;    
      }
      catch (FeedException fe)
	  {
        eventManager.fehlerMeldung("Probleme beim PARSEN des Feeds.");      	
	  }      
      catch (Exception e) 
	  {
      	eventManager.fehlerMeldung("Probleme beim LESEN des Feeds.");      
	  }
	
	}
	
	public void importRssChannel(com.sun.syndication.feed.rss.Channel channel)
	{
      // Channelnamen extrahieren bzw. Vorgabe benutzen		
	  String channelName = this.channelFilter_Name;
	  if (channelName.equals("")) channelName = channel.getTitle();
	  
	  // Die NewsItems extrahieren
	  List newsItems = channel.getItems();
	  
	  // Die NewsItems importieren
	  if (newsItems!=null)
	  for (ListIterator li1 = newsItems.listIterator(); li1.hasNext();)
	  {
	    Item newsItem = (Item) li1.next();	
	    
	    // Titel extrahieren
	    String titel = newsItem.getTitle();
	    System.out.println("Gefunden: '"+titel+"'");
	    
	    // Autor extrahieren
	    String author = newsItem.getAuthor();
        if ((author==null) || (author.equals(""))) author = "Autor unbekannt";	
        
	    // Mit vorhandenen Daten NewsObjekt erzeugen 
	    NewsObject NewsObjekt = new NewsObject(titel,author,channelName); 
	    NewsObjekt.setImportance(this.channelFilter_Importance); 	    
	    
	    // -- Zusatzdaten sammeln --
	    
	    // Beschreibung extrahieren
	    String description = "";	    
	    Description descObj = newsItem.getDescription();
	    if (descObj!=null) description = descObj.getValue();
	    if ((!description.equals("")) && (!description.equals(titel))) NewsObjekt.addText(description, this.feedUrl);

	    // Publikationsdatum extrahieren
	    java.util.Date pubDate = newsItem.getPubDate();
	    if (pubDate!=null) { NewsObjekt.setDate(pubDate.getTime()); }
	    else { pubDate = new java.util.Date(); }
	    
	    // Enclosures extrahieren (das sind URLS auf Datein / wie Anhnge)
	    List enclosures = newsItem.getEnclosures();
	    if (enclosures!=null)
	    for (ListIterator li2 = enclosures.listIterator(); li2.hasNext();)
	    {
	      Enclosure enObj = (Enclosure) li2.next();
	      String    enTyp = enObj.getType();
	      
	      if (enTyp.startsWith("image/"))
	      {
	        // Bilddatei gefunden
	      	System.out.println("- Mit BildObjekt: '"+enObj.getUrl()+"'");
		    if (!enObj.getUrl().equals("")) NewsObjekt.addImage(enObj.getUrl());
	      }
	      else { System.out.println("- Unbekannter Anhang: '"+enTyp+"'"); }
	    }
        
	    // -- NewsObjekt speichern --
	    this.addNewsObject(NewsObjekt);
	    
	  }
	}
	

	// Diese Methode importiert die Nachrichten des bergebenen Feeds in  
	public void importSyndFeed(SyndFeed rssFeed)
	{
      try {
      	
       String channelName;
   	   if (this.channelFilter_Name.equals(""))
   	   { channelName = rssFeed.getTitle(); }
   	   else
   	   { channelName = this.channelFilter_Name;}
   	   
   	   List newsItems = rssFeed.getEntries();
 	   
       for (java.util.ListIterator li=newsItems.listIterator();li.hasNext();)
       {
      	
     	 com.sun.syndication.feed.synd.SyndEntryImpl newsItem = (com.sun.syndication.feed.synd.SyndEntryImpl) li.next();

 	     // NewsObjekt erstellen und einlagern
         String headline = newsItem.getTitle();
 	     System.out.println("Gefunden: '"+headline+"'");          
         String author   = newsItem.getAuthor();
         if ((author==null) || (author.equals("")))
         {
           author = "Autor unbekannt";	
         }
         
 	     NewsObject NewsObjekt = new NewsObject(headline,author,channelName); 

 	     try{     
 	     	 // Beschreibung auswerten ---------------
 	     	 String descriptionStr = "";

 	     	 // 1. Versuch ber die Contentitems
 	     	 	List contents = newsItem.getContents();
 	     	 	if ((contents != null) && (contents.size()>0))
 	     	 	{
 	     	 		for (ListIterator list = contents.listIterator();list.hasNext();)
 	     	 		{
 	     	 		  com.sun.syndication.feed.synd.SyndContent content = (com.sun.syndication.feed.synd.SyndContent) list.next();
 	     	 		  if (content.getClass().getName().equals("com.sun.syndication.feed.synd.SyndContentImpl"))
 	     	 		  {
 	     	 		      SyndContentImpl contentImpl = (SyndContentImpl) content;
 	     	 		  	  // System.out.println("ItemContent:'"+contentImpl.getType()+"/"+contentImpl.getValue()+"'"); 	     	 		  	 	 		  	
 	 	     	 		  descriptionStr = content.getValue(); 	     	 		  	
 	     	 		  }
 	     	 		  else
 	     	 		  {
 	     	 		  	System.out.println("Unbekanntes ItemContent:'"+content.getClass().getName()+"'");
 	     	 		  }
 	     	 		}
 	     	 	}
 	     	 	
 	 	     	 // 2. Versuch nun direkt	     	 	
 	     	 	if (descriptionStr.equals(""))
 	     	 	{
 	   	     	  com.sun.syndication.feed.synd.SyndContent description = newsItem.getDescription();
 	   	     	  if (description!=null)	   
 	   	     	  {
 	   		 	    descriptionStr = description.getValue();	   	     	  	
 	   	     	  }
 	     	 	}
 	     	 	
		
	 	     // prfen, ob die headline unterschiedlich von der beschreibung ist
	 	     if ((descriptionStr.length() >0) && (!descriptionStr.equals(headline)))
	 	     {
	 	       NewsObjekt.addText(descriptionStr,this.feedUrl);
	 	     }
 	     	 
 	     	 // Datum der Nachricht auswerten -------------
 	     	 Date datum = newsItem.getPublishedDate();
 	     	 if (datum!=null)
 	     	 {
 	     	 	NewsObjekt.setDate(datum.getTime());   	
 	     	 }
 	     }
 	     // bei Description kann aus zu einer NullpointerException kommen
 	     catch (Exception e) { System.out.println( "-- Fehler bei der Contentauswertung --"); }
	     
 	     NewsObjekt.setImportance(this.channelFilter_Importance); 	     
 	     
	 	     this.addNewsObject(NewsObjekt); 			 	     
 	   }
       
      }
      catch (Exception e)
	  {
      	eventManager.fehlerMeldung("FEHLER NewsContainer@importFeed :: Fehler bei Bearbeitung des Feeds.");         	
	  }    
	}		
	
	public String toString()
	{
	  String output = "NEWSCONTAINER:";	
	  int i = 1;
      for (Enumeration e = NewsObjectContainer.elements() ; e.hasMoreElements() ;) 
      {
      	NewsObject news = ((NewsObject)(e.nextElement()));
        output += "\n "+i+"::"+news;
        ++i;
      }	
      return output;
	}
	
	public void internalProgramEventHappend(InternalProgramEvent ipe)
	{
	  // hier die ankommenden Events auswerten			
      String eventName = ipe.getName();	
      
	  if (eventName.equals("dataInfoUpdateRequest"))
	  {
	  	// DatenBericht dieses Objektes zusammenstellen und verschicken
	  	eventManager.dataInfoUpdate(this.toString());
	  }				
	}
	
	// Liefert alle Kinder eines XML-Elements mit dem ensprechenden Namen zurck
	private Vector getAllChildrensWithName(Element base, String name)
	{
	  Vector result = new Vector(1,5);	
      List Elements = base.getChildren();
      for (int i=0; i < Elements.size();i++)
      {
        Element element =  (Element) Elements.get(i); 	
        if (element.getName().equals(name))
        {
         result.add(element); 	
        }     
      }
      return result;
	};
	
	// Liefert Text des Unter-Elementes aus dem Vater-Element
	private String getTextFromChild(Element base, String name)
	{
	  String result = "";
      List Elements = base.getChildren();
      for (int i=0; i < Elements.size();i++)
      {
        Element element =  (Element) Elements.get(i); 	
        if (element.getName().equals(name))
        {
         result = element.getTextNormalize();	
        }     
      }	  
	  return result;
	}
}
