/*
 * Created on 19.11.2004
 */
package infoscreen;

import java.util.*;
import java.net.*;

/**
 * @author Christian Desktop
 */
public class NewsObject {
	
	// EINSTELLUNGSKONSTANTEN
	private final int maxCharsPerTextpage   = 400;
	private final int maxCharsPerNewsObject = 4000;
	
	// NEWSOBJECTDATEN	
	private String Headline			= "";
	private String Subheadline		= "";
	private String Author			= "";
	private String Channelname		= "";
	private int	   Importance		= 3;
	
	private boolean dirty			= false;
	
	private long   Date;
	private long   lastScreening;
	private Vector NewsComponents;
	
	public NewsObject (String headline, String author, String channelname)
	{
	  this.Headline 		= headline;
	  this.Author   		= author;
	  this.Channelname 		= channelname;
	  this.lastScreening	= (new Date()).getTime();
	  
	  // Systemdatum eintragen
	  Date date = new Date();
	  this.Date	= date.getTime();
	  
	  // NewsComponentsVector anlegen
	  this.NewsComponents = new Vector(1,1);
	}
	
	public void setSubheadline (String subheadline)
	{
	  this.Subheadline = subheadline;	
	}
	
	public void setDate (long date)
	{
	  this.Date = date;	
	}	
	
	public void setImportance (int imp)
	{
	  this.Importance = imp;	
	}	
	
	public int getImportance ()
	{
	  return this.Importance;	
	}		

	public void setDirty(boolean wert)
	{
	  this.dirty=wert; 	
	}
	
	public boolean getDirtyFlag()
	{
	  return this.dirty;	
	}
	
	public int getSize()
	{
	  return this.NewsComponents.size();		
	}
	
	public void addNewsComponent (NewsComponent component)
	{
	  this.NewsComponents.add(component);	
	}
	
	public NewsComponent getNewsComponent(int id)
	{
	  NewsComponent result = null;
	    if (id < this.NewsComponents.size())
	    {
	      result = (NewsComponent)this.NewsComponents.get(id); 	
	    }
	  return result;
	}
	
	private String getUrlFromImageTag(String tag, String feedUrl)
	{
	  int startIndex = tag.indexOf("src=");
	  if (startIndex==-1) startIndex = tag.indexOf("SRC=");
	  
	  int endIndex = tag.indexOf(" ",startIndex);
	  if (endIndex==-1) endIndex = tag.indexOf(">",startIndex);
	  
	  if ((startIndex>0) && (endIndex>0))
	  {
	  	String imageurl = "";
	    imageurl = tag.substring(startIndex+5, endIndex-1);	
	    
	    // Bildadreses ggf. umbauen
	    if (!imageurl.startsWith("http://"))
	    {
		  if ((feedUrl.indexOf("infoscreenCom.php")==-1))	
		  {
	        String urlBase = feedUrl.substring(0,feedUrl.lastIndexOf("/"));
	        imageurl = urlBase+"/"+imageurl;
		  }
		  else
		  {
	        String urlBase = feedUrl.substring(feedUrl.indexOf("url="+4),feedUrl.lastIndexOf("/"));
	        imageurl = urlBase+"/"+imageurl;		  	
		  }
	    }
	    
	    // Bild ggf. ber Proxy geladen werden
	    if ((feedUrl.indexOf("infoscreenCom.php")>-1))
	    {
	      String urlBase = feedUrl.substring(0,feedUrl.indexOf("url=")+4);
	      imageurl = urlBase+imageurl;
	    }	    
	    
	    return imageurl;
	  }
	  else
	  {
	    return "";	
	  }
	  
	}
	
	private boolean analyseStructureOfText(String Text, String feedUrl) 
	{
	   Text = Text.trim();	
	   if ((Text.indexOf("<img ") != -1) || (Text.indexOf("<IMG ") != -1))
	   {
	   	 //System.out.println("- ImageTag gefunden: ------");
	   	 
	   	 int startIndex = Text.indexOf("<img ");
	   	 if (startIndex==-1) startIndex = Text.indexOf("<IMG ");
	   	 
	   	 int endIndex   = Text.indexOf(">",startIndex);
	   	 
	   	 if (startIndex < endIndex)
	   	 {
	   	   // Text vor ImageTag bearbeiten
	   	   if (startIndex > 1)
	   	   {
	   	     String beforeText = Text.substring(0,(startIndex-1));
	   	     if (!beforeText.trim().equals(""))
	   	     {
	   	       //System.out.println("--VorText:"+beforeText);
	   	       this.addText(beforeText, feedUrl);
	   	     }
	   	   }
	   	   
	   	   // ImageTag bearbeiten
	   	   String imageTag = Text.substring(startIndex, endIndex+1);
	   	   String imageURL = this.getUrlFromImageTag(imageTag, feedUrl);
   	       System.out.println("- Bild:"+imageURL);
   	       this.addImage(imageURL);
	   	   
	   	   // Text nach dem Tag bearbeiten   	   
  	       if (endIndex < (Text.length()-1))
	   	   {
	   	     String afterText = Text.substring(endIndex+1);
	   	     if (!afterText.trim().equals(""))
	   	     {
	   	       //System.out.println("--NachText:"+afterText);
	   	       this.addText(afterText, feedUrl);
	   	     }
	   	   }	   	   
		   return true;	   	 	
	   	 }
	   	 else
	   	 {
		   return false;	   	 	
	   	 }
	   }
	   else
	   {
	   	 //System.out.println("- kein ImageTag gefunden.");
	     return false; 
	   }
	}
	
	private Vector arrayToVector(Object[] array)
	{
	  Vector output = new Vector (10,20);	
	    for (int i=0; i<array.length; i++) 
	    {
	      output.add(i,array[i]); 	
	    }
	  return output;	
	}
	
	private String filterText(String orgText)
	{
	  String output = orgText;
	  
	  output = removeHtmlTags(output);	  
	  output = convertExtendedCharactersToIsoLatin(output);
	  
	  int index = output.indexOf("Diese Nachricht wurde von Pinnwand");
	  if (index>0) {output = output.substring(0,index-1);}
	  
	  return output;
	}
	
	  public static String convertExtendedCharactersToIsoLatin(String input)
	  {
		StringBuffer buffer = new StringBuffer(input);
		StringBuffer output = new StringBuffer();
		for (int i = 0; i < buffer.length(); i++)
		{
		  if (buffer.charAt(i) == '"')
			output.append("&quot;");
		  else if (buffer.charAt(i) == '')
		    output.append("&auml;");
		  else if (buffer.charAt(i) == '')
		    output.append("&Auml;");
		  else if (buffer.charAt(i) == '')
		    output.append("&uuml;");
		  else if (buffer.charAt(i) == '')
		    output.append("&Uuml;");
		  else if (buffer.charAt(i) == '')
		    output.append("&ouml;");
		  else if (buffer.charAt(i) == '')
		    output.append("&Ouml;");
		  else if (buffer.charAt(i) == '')
		    output.append("&szlig;");		  
		  else
			output.append(buffer.charAt(i));
		}
		return output.toString();
	  }
	
	  public static String removeHtmlTags(String ins)
	  {
		StringBuffer finalStr = new StringBuffer();

		boolean intag = false;
		for (int i=0; i<ins.length(); i++)
		{
		  if (!intag)
		  {
			if (ins.charAt(i) == '<')
			  intag = true;
			else if (ins.charAt(i) != '\t' && ins.charAt(i)!= '\n')
			   finalStr.append(ins.charAt(i));
		  }
		  else if (ins.charAt(i) == '>')
		  {
		  	// <br> nicht lschen
		    if ((i>5) && (ins.charAt(i-2)=='b') && (ins.charAt(i-1)=='r'))	
		    { finalStr.append("<br>");}
		    
		  	// <b> nicht lschen
		    if ((i>2) && (ins.charAt(i-1)=='b'))	
		    { finalStr.append("<b>");}	
		    
		  	// </b> nicht lschen
		    if ((i>4) && (ins.charAt(i-2)=='/') && (ins.charAt(i-1)=='b'))		
		    { finalStr.append("</b>");}			
		    
		  	// <i> nicht lschen
		    if ((i>2) && (ins.charAt(i-1)=='i'))	
		    { finalStr.append("<b>");}	
		    
		  	// </i> nicht lschen
		    if ((i>4) && (ins.charAt(i-2)=='/') && (ins.charAt(i-1)=='i'))		
		    { finalStr.append("</b>");}				    
		    
			intag=false;
		  }
		  else
		  {

		  }
		}
		return finalStr.toString();
	  }
	
	public void addText (String text, String feedurl)
	{	
	
	  if (!analyseStructureOfText(text, feedurl))
	  {
		
	  text = this.filterText(text);	
		
	  if (this.maxCharsPerTextpage < text.length())
	  {
	  	// --- Text wird auf mehrere Textseiten aufgeteilt
	  	int wholeChars = 0;
	  	int minCharsPerTextpage = (int)(this.maxCharsPerTextpage * 0.3);
	  	
	  	// Text wird in Stze aufgeteilt
	  	StringTokenizer phrases = new StringTokenizer(text,".?",true);	  
	  	
	  	String pageText = "";
	  	String restPhrase = "";	  
	  	String nextPhrase = "";
	  	while ( ((phrases.hasMoreElements()) || (restPhrase.length() > 0) ) && (wholeChars < this.maxCharsPerNewsObject))
	  	{		
		  pageText = "";	  
		  
		  // Soviele Stze wie mglich in den SeitenText schreiben
	  	  while ((phrases.hasMoreElements()) || (restPhrase.length() > 0) )
	  	  {
	  	  	
	  	  	// nchsten Satz holen oder Reste verwerten
			if (restPhrase.length() > 0) {nextPhrase = restPhrase; restPhrase = "";}
			else 						 {nextPhrase = (String) phrases.nextElement();}	
	  	  	
			if ((pageText + nextPhrase).length() < this.maxCharsPerTextpage)
			{
			  // Der nchste Satz passt noch rein	
			  pageText = pageText + nextPhrase;			
			}
			else
			{
		      // Innere WhileSchleife abbrechen, weil der nchste Satz den Rahmen sprengt
			  // Der nchste Satz bleibt in nextPhrase
			  break;	
			} 
	  	  }

          // Prfen, ob schon die Mindestlnge des Seitentextes erreicht ist
	  	  if (pageText.length() > minCharsPerTextpage) 
	  	  {
	  	    // Die Mindestlnge ist schon erreicht
	  	  	// der nchste Satz wird in restPhrase gespeichert
	  	  	restPhrase = nextPhrase;
	  	  }
	  	  else
	  	  {
	  	    // Die Mindestlnge ist noch nicht erreicht
	  	  	// Der nextPhrase wird in einzelne Worte zerlegt
	  	  	
	  	    StringTokenizer words = new StringTokenizer(nextPhrase," ",true);
	  	    
	  	    // soviele Worte wie mglich in den SeitenText schreiben.
            while ( ((pageText.length() < this.maxCharsPerTextpage) && (words.hasMoreElements()) ))
	  	    {
	  	      pageText = pageText + (String) words.nextElement();	
	  	    }     
            
  	  	    // die brige Worte in restPhrase merken
            while ((words.hasMoreElements()))
            {
              restPhrase = restPhrase + words.nextElement();
            }
	  	  }
	  	  
	  	  // Die TextSeite speichern
	  	  if (!pageText.equals(""))
	  	  {
		    NewsText nText = new NewsText(pageText);
		    this.addNewsComponent(nText);
		    wholeChars = wholeChars + pageText.length();
	  	  }	  	
	  	  else
	  	  {
	  	  	// Wenn wirklich sogar ein Wort ber eine Seite ragt, kann das kein vernnftiger Text sein
	  	  	// Er wird halt ignoriert ... pech gehabt :-)
		    System.out.println("- Beschreibungstext wird ignoriert.");	  	  	
	  	    break;
	  	  }
	  	}	
	  }
	  else
	  {
	  	// --- Text kann auf einer Textseite dargestellt werden
	    NewsText nText = new NewsText(text);
	    this.addNewsComponent(nText);	  
	  }
	  }
	}
	
	public void addImage(String urlstr)
	{
	  try {
	  	URL url = new URL(urlstr); 
	  	javax.swing.ImageIcon img = new javax.swing.ImageIcon(url);
	  	NewsImage newsImage = new NewsImage(img);
	    this.addNewsComponent(newsImage);		  	
	  }
	  catch (Exception e)
	  {
	    System.out.println("- Fehler bei Laden des Bildes.");	
	  }
	}
	
	public String getHeadline ()
	{
	  return this.Headline;	
	}
	
	public String getChannelName()
	{
	  return this.Channelname;	
	}
	
	public String getAuthor()
	{
	  return this.Author;	
	}
	
	public long getDate()
	{
	  return this.Date;	
	}
	
	public long getDisplayTimestamp()
	{
	  return this.lastScreening;
	}
	
	// Markiert das NewsObjekt als zur aktuellen Zeit angezeigt
	public void setDisplayed()
	{
	  Date actualDate = new Date();		
	  this.lastScreening = actualDate.getTime(); 	
	}
	
	// Markiert das NewsObjekt als zur aktuellen Zeit angezeigt
	public void setDiplayedBack(int halfminutes)
	{
	  this.lastScreening = this.lastScreening -(halfminutes*30*1000); 	
	}	
	
	public String toString()
	{
	  Date published = new Date(this.Date);
	  Date screened  = new Date(this.lastScreening);
	  String output = "NewsObjekt: lastscreen:"+screened.toGMTString()+" ch:"+this.Channelname+" hl:"+this.Headline;
	  return output;
	}
}
