/*
 * Created on 18.11.2004
 */
package infoscreen;

import java.awt.Color;
import java.awt.Dimension;

import java.awt.*;
import javax.swing.*;

// TableLayout from
// http://java.sun.com/products/jfc/tsc/articles/tablelayout/
import layout.*;

/**
 * @author Christian Desktop
 */
public class NewsRenderer 
  implements InternalProgramEventListener
{
    private GuiObjects 					guiObjects;
	private InternalProgramEventManager	eventManager;
	private JEditorPane 				renderPanel;
	
	public NewsRenderer (GuiObjects guiRef, InternalProgramEventManager ipem)
	{
	  // Referenzen kopieren
	  this.eventManager = ipem; 
	  this.guiObjects   = guiRef;
	  
	  // Beim eventManager registrieren
	  this.eventManager.register(this);		
	  
	  // renderPanel einrichten
	  this.renderPanel = new JEditorPane();
	  this.renderPanel.setEditable( false );
	  this.renderPanel.setContentType("text/html; charset=iso-8859-1");	  
	}
	
	public int  renderHeadline(NewsObject newsObject)
	{
      JPanel newsSlide = buildNewsSlide(newsObject, 1);
	  String headline 	= newsObject.getHeadline();
	  
      // Headline-Element erstellen
	  this.renderPanel.setText("<html><body bgcolor='#000000' text='#FFCCCC' link='#FF99FF' vlink='#FF99FF' alink='#FFFFFF'><br><center><b><font size='30' face='Avalon,Wide Latin'>"+headline+"</b></font><br></center></body></html>");
	  this.renderPanel.setContentType("text/html; charset=iso-8859-1");	  
      this.renderPanel.setOpaque(true);      
      this.renderPanel.setBackground(Color.black);
	  newsSlide.add(this.renderPanel, "1,1,2,1,C,C");	
	  
	  // bergabe der Informationen an GuiObjects
	  newsSlide.setPreferredSize(new Dimension((guiObjects.getScreenWidth()),(guiObjects.getScreenHeight()-3)));
	  this.guiObjects.setNewsShowPanel(newsSlide); 	 	  
	  
	  return 6000; // 6 Sekunden	
	}
	
	private JPanel buildNewsSlide(NewsObject newsObject, int number)
	{
		  // get Data out of Newsobject
		  String channel  	= newsObject.getChannelName();
		  String author     = newsObject.getAuthor();
		  long   date		= newsObject.getDate();
		  int    NewsPages	= newsObject.getSize() +1;
				
		  // Init HeadlinePanel
		  JPanel newsSlide = new JPanel();
		  newsSlide.setForeground(new Color(0,0,0,50));	  
	      double layout[][] =
	      {{20, TableLayout.FILL, 400, 20},
	       {80, TableLayout.FILL, 50}};	  	  
	      newsSlide.setLayout(new TableLayout(layout));
		  
		  // ChannelName-Element erstellen
		  JLabel chan = new JLabel(channel);
		  chan.setFont( new Font("Latin", Font.BOLD, 25) );
	      chan.setOpaque(true);
	      chan.setBackground(Color.black);
	      chan.setForeground(new Color((float)1,(float)1,(float)1));	  
		  newsSlide.add(chan, "1,0,L,C");
		  
		  // Index-Element erstellen
		  JLabel ind = new JLabel("("+number+"/"+NewsPages+")");
		  ind.setFont( new Font("Latin", Font.BOLD, 25) );	  
	      ind.setOpaque(true);
	      ind.setBackground(Color.black);
	      ind.setForeground(new Color((float)1,(float)1,(float)1));		  
		  newsSlide.add(ind, "2,0,R,C");		  
		  
		  // Autor-Element erstellen
		  JLabel aut = new JLabel(author);
		  aut.setFont( new Font("Latin", Font.BOLD, 20) );
	      aut.setOpaque(true);
	      aut.setBackground(Color.black);
	      aut.setForeground(new Color((float)1,(float)1,(float)1));		  
		  newsSlide.add(aut, "1,2,L,C");	
		  	  
		  // Datum-Element erstellen
		  java.util.Date dateObject = new java.util.Date(date); 
		  JLabel dat = new JLabel(dateObject.toGMTString().trim());
		  dat.setFont( new Font("Latin", Font.BOLD, 20) );
	      dat.setOpaque(true);
	      dat.setBackground(Color.black);
	      dat.setForeground(new Color((float)1,(float)1,(float)1));		  
		  newsSlide.add(dat, "2,2,R,C");
		  
		  return newsSlide;
	}
	
	public void rederNewsflash (String newsText)
	{
	  outputSimpleText(newsText);	  	
	}
	
	public int renderNewsComponent(NewsObject newsObject, int numberOfComponent)
	{
	   NewsComponent actualComponent = newsObject.getNewsComponent(numberOfComponent);
	   int Duration = 10;
	   if (actualComponent!=null)
	   {
	   	 // Aktuelles NewsComponent ist ein NewsText-Objekt
	     if (actualComponent.getType().equals("Text"))
	     {
	       Duration = this.renderNewsTextObject(newsObject, (NewsText)actualComponent, numberOfComponent);	
	     }
	     else if (actualComponent.getType().equals("Image"))
	     {
	     	NewsImage newsImage = (NewsImage) actualComponent; 
	     	if (newsImage.getImage().getImageLoadStatus()==MediaTracker.COMPLETE)
	     	{
	     	  // Bild ist geladen
		      Duration = this.renderNewsImageObject(newsObject, newsImage, numberOfComponent);	
	     	}
	     	else
	     	{
	     	  // Bild wurde noch nicht geladen. Warum? 	
	     	  if ((newsImage.getImage().getImageLoadStatus()==MediaTracker.ABORTED) ||
	     	  	  (newsImage.getImage().getImageLoadStatus()==MediaTracker.ERRORED))
	     	  {
	     	    // Es gab Probleme mit dem Image
	     	  	outputSimpleText("Bild konnte nicht geladen werden.");
	     	  	// Bild aus NewsObjekt entfernen
	     	  	// --- muss noch gemacht werden
	     	  	Duration = 1000;
	     	  }
	     	}
	     }
	     else 
	     {
	       Duration = 1000;	
	 	   this.outputSimpleText("Unbekannter Newscomponent-Typ");	       
	     }
	   }
	   return Duration;
	}
	
	private int renderNewsTextObject(NewsObject newsSource, NewsText newsText, int numberOfComponent)
	{
		
      JPanel newsSlide = buildNewsSlide(newsSource, (numberOfComponent+2));
	  String text      = newsText.getText();
	  
      // Headline-Element erstellen
	  this.renderPanel.setText("<html><body bgcolor='#000000' text='#FFCCCC' link='#FF99FF' vlink='#FF99FF' alink='#FFFFFF'><br><center><b><font size='30' face='Avalon,Wide Latin'>"+text+"</b></font><br></center></body></html>");
	  this.renderPanel.setContentType("text/html; charset=iso-8859-1");	  
      this.renderPanel.setOpaque(true);      
      this.renderPanel.setBackground(Color.black);
	  newsSlide.add(this.renderPanel, "1,1,2,1,C,C");	
	  
	  // bergabe der Informationen an GuiObjects
	  newsSlide.setPreferredSize(new Dimension((guiObjects.getScreenWidth()),(guiObjects.getScreenHeight()-3)));
	  this.guiObjects.setNewsShowPanel(newsSlide); 	 	  
	  
	  // AnzeigeDauer kalkulieren
	  int Duration = text.length() * 50;
	  if (Duration < 5000) Duration = 5000; 
	  
	  return Duration;	
	}
	
	private int renderNewsImageObject(NewsObject newsSource, NewsImage newsImage, int numberOfComponent)
	{
		
      JPanel newsSlide = buildNewsSlide(newsSource, (numberOfComponent+2));
	  ImageIcon image      = newsImage.getImage();
	  
      // Bild einfgen
	  newsSlide.add(new JLabel("Text", image, JLabel.CENTER), "1,1,2,1,C,C");	
	  
	  // bergabe der Informationen an GuiObjects
	  newsSlide.setPreferredSize(new Dimension((guiObjects.getScreenWidth()),(guiObjects.getScreenHeight()-3)));
	  this.guiObjects.setNewsShowPanel(newsSlide); 	 	  
	  
	  return 10000; // 10 Sekunden		
	}	
	
	private void outputSimpleText(String text)
	{
	  JPanel headlinePanel = new JPanel();
	  headlinePanel.setForeground(new Color(0,0,0,50));
	  this.renderPanel.setText("<html><body bgcolor='#000000' text='#FFFFFF' link='#FF99FF' vlink='#FF99FF' alink='#FFFFFF'><br><center><b><font size='20' face='Avalon,Wide Latin'>"+text+"</b></font><br></center></body></html>");
	  this.renderPanel.setContentType("text/html; charset=iso-8859-1");	  
	  this.renderPanel.setPreferredSize(new Dimension((guiObjects.getScreenWidth()),(guiObjects.getScreenHeight()-3)));
	  headlinePanel.add(this.renderPanel);
	  this.guiObjects.setNewsShowPanel(headlinePanel); 	  	
	}
	
	// Gibt eine ZwischenAnimation auf GuiObjects aus
	// Gibt die Dauer der Animation zurck
	public int renderBetweenAnimation ()
	{
	  JPanel headlinePanel = new JPanel();
	  headlinePanel.setForeground(new Color(0,0,0,50));
	  ImageIcon icon1 = new ImageIcon("Butterfly.gif");
	  JLabel l1 = new JLabel();
	  l1.setForeground(new Color(100,0,0,20));	  
	  l1.setPreferredSize(new Dimension((guiObjects.getScreenWidth()),(guiObjects.getScreenHeight()-3)));
	  headlinePanel.add(l1);
	  this.guiObjects.setNewsShowPanel(headlinePanel); 	
	  return 1000; // 1500 Millisekunden	
	}
	
	public void internalProgramEventHappend(InternalProgramEvent ipe)
	{
	  // hier die ankommenden Events auswerten	
	}  	
}
